/* -*- c-basic-offset:4; c-indentation-style:"k&r"; indent-tabs-mode:nil -*- */

/** 
 * @file parser.h
 * Pathfinder parser and lexer interface.  Parse tree interface.
 *
 *
 * Copyright Notice:
 * -----------------
 *
 * The contents of this file are subject to the Pathfinder Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License.  You may obtain a copy of the License at
 * http://monetdb.cwi.nl/Legal/PathfinderLicense-1.1.html
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See
 * the License for the specific language governing rights and limitations
 * under the License.
 *
 * The Original Code is the Pathfinder system.
 *
 * The Original Code has initially been developed by the Database &
 * Information Systems Group at the University of Konstanz, Germany and
 * the Database Group at the Technische Universitaet Muenchen, Germany.
 * It is now maintained by the Database Systems Group at the Eberhard
 * Karls Universitaet Tuebingen, Germany.  Portions created by the
 * University of Konstanz, the Technische Universitaet Muenchen, and the
 * Universitaet Tuebingen are Copyright (C) 2000-2005 University of
 * Konstanz, (C) 2005-2008 Technische Universitaet Muenchen, and (C)
 * 2008-2010 Eberhard Karls Universitaet Tuebingen, respectively.  All
 * Rights Reserved.
 *
 * $Id$
 */

#ifndef PARSER_H
#define PARSER_H

#include <stdio.h>
#include "abssyn.h"
#include "pf_xq.h"


/* initialize global variables */
void PFparser_init (void);

/**
 * Parse an XQuery from the main-memory buffer pointed to by @a input.
 */
int PFparse (char* pfin, PFpnode_t **, PFquery_t *PFquery, bool standoff);

/**
 * Load and parse modules listed in working list and put them into
 * the parse tree @a r.
 */
int PFparse_modules (PFpnode_t *r, PFquery_t *PFquery, bool standoff);

#endif   /* PARSER_H */

/* vim:set shiftwidth=4 expandtab: */
